diff --git a/tools/testing/selftests/proc/.gitignore b/tools/testing/selftests/proc/.gitignore
index a156ac5dd2c6..448db45f08dc 100644
--- a/tools/testing/selftests/proc/.gitignore
+++ b/tools/testing/selftests/proc/.gitignore
@@ -13,8 +13,6 @@
 /proc-self-wchan
 /proc-subset-pid
 /proc-tid0
-/proc-uptime-001
-/proc-uptime-002
 /read
 /self
 /setns-dcache
diff --git a/tools/testing/selftests/proc/Makefile b/tools/testing/selftests/proc/Makefile
index cd95369254c0..22ff9341f97c 100644
--- a/tools/testing/selftests/proc/Makefile
+++ b/tools/testing/selftests/proc/Makefile
@@ -16,8 +16,6 @@ TEST_GEN_PROGS += proc-self-syscall
 TEST_GEN_PROGS += proc-self-wchan
 TEST_GEN_PROGS += proc-subset-pid
 TEST_GEN_PROGS += proc-tid0
-TEST_GEN_PROGS += proc-uptime-001
-TEST_GEN_PROGS += proc-uptime-002
 TEST_GEN_PROGS += read
 TEST_GEN_PROGS += self
 TEST_GEN_PROGS += setns-dcache
diff --git a/tools/testing/selftests/proc/proc-uptime-001.c b/tools/testing/selftests/proc/proc-uptime-001.c
deleted file mode 100644
index 781f7a50fc3f..000000000000
--- a/tools/testing/selftests/proc/proc-uptime-001.c
+++ /dev/null
@@ -1,45 +0,0 @@
-/*
- * Copyright © 2018 Alexey Dobriyan <adobriyan@gmail.com>
- *
- * Permission to use, copy, modify, and distribute this software for any
- * purpose with or without fee is hereby granted, provided that the above
- * copyright notice and this permission notice appear in all copies.
- *
- * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
- * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
- * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
- * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
- * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
- * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
- * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
- */
-// Test that values in /proc/uptime increment monotonically.
-#undef NDEBUG
-#include <assert.h>
-#include <stdint.h>
-#include <sys/types.h>
-#include <sys/stat.h>
-#include <fcntl.h>
-
-#include "proc-uptime.h"
-
-int main(void)
-{
-	uint64_t start, u0, u1, i0, i1;
-	int fd;
-
-	fd = open("/proc/uptime", O_RDONLY);
-	assert(fd >= 0);
-
-	proc_uptime(fd, &u0, &i0);
-	start = u0;
-	do {
-		proc_uptime(fd, &u1, &i1);
-		assert(u1 >= u0);
-		assert(i1 >= i0);
-		u0 = u1;
-		i0 = i1;
-	} while (u1 - start < 100);
-
-	return 0;
-}
diff --git a/tools/testing/selftests/proc/proc-uptime-002.c b/tools/testing/selftests/proc/proc-uptime-002.c
deleted file mode 100644
index 7d0aa22bdc12..000000000000
--- a/tools/testing/selftests/proc/proc-uptime-002.c
+++ /dev/null
@@ -1,79 +0,0 @@
-/*
- * Copyright © 2018 Alexey Dobriyan <adobriyan@gmail.com>
- *
- * Permission to use, copy, modify, and distribute this software for any
- * purpose with or without fee is hereby granted, provided that the above
- * copyright notice and this permission notice appear in all copies.
- *
- * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
- * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
- * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
- * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
- * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
- * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
- * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
- */
-// Test that values in /proc/uptime increment monotonically
-// while shifting across CPUs.
-#undef NDEBUG
-#include <assert.h>
-#include <errno.h>
-#include <unistd.h>
-#include <sys/syscall.h>
-#include <stdlib.h>
-#include <string.h>
-
-#include <stdint.h>
-#include <sys/types.h>
-#include <sys/stat.h>
-#include <fcntl.h>
-
-#include "proc-uptime.h"
-
-static inline int sys_sched_getaffinity(pid_t pid, unsigned int len, unsigned long *m)
-{
-	return syscall(SYS_sched_getaffinity, pid, len, m);
-}
-
-static inline int sys_sched_setaffinity(pid_t pid, unsigned int len, unsigned long *m)
-{
-	return syscall(SYS_sched_setaffinity, pid, len, m);
-}
-
-int main(void)
-{
-	unsigned int len;
-	unsigned long *m;
-	unsigned int cpu;
-	uint64_t u0, u1, i0, i1;
-	int fd;
-
-	/* find out "nr_cpu_ids" */
-	m = NULL;
-	len = 0;
-	do {
-		len += sizeof(unsigned long);
-		free(m);
-		m = malloc(len);
-	} while (sys_sched_getaffinity(0, len, m) == -1 && errno == EINVAL);
-
-	fd = open("/proc/uptime", O_RDONLY);
-	assert(fd >= 0);
-
-	proc_uptime(fd, &u0, &i0);
-	for (cpu = 0; cpu < len * 8; cpu++) {
-		memset(m, 0, len);
-		m[cpu / (8 * sizeof(unsigned long))] |= 1UL << (cpu % (8 * sizeof(unsigned long)));
-
-		/* CPU might not exist, ignore error */
-		sys_sched_setaffinity(0, len, m);
-
-		proc_uptime(fd, &u1, &i1);
-		assert(u1 >= u0);
-		assert(i1 >= i0);
-		u0 = u1;
-		i0 = i1;
-	}
-
-	return 0;
-}
diff --git a/tools/testing/selftests/proc/proc-uptime.h b/tools/testing/selftests/proc/proc-uptime.h
deleted file mode 100644
index dc6a42b1d6b0..000000000000
--- a/tools/testing/selftests/proc/proc-uptime.h
+++ /dev/null
@@ -1,60 +0,0 @@
-/*
- * Copyright © 2018 Alexey Dobriyan <adobriyan@gmail.com>
- *
- * Permission to use, copy, modify, and distribute this software for any
- * purpose with or without fee is hereby granted, provided that the above
- * copyright notice and this permission notice appear in all copies.
- *
- * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
- * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
- * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
- * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
- * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
- * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
- * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
- */
-#undef NDEBUG
-#include <assert.h>
-#include <errno.h>
-#include <string.h>
-#include <stdlib.h>
-#include <unistd.h>
-
-#include "proc.h"
-
-static void proc_uptime(int fd, uint64_t *uptime, uint64_t *idle)
-{
-	uint64_t val1, val2;
-	char buf[64], *p;
-	ssize_t rv;
-
-	/* save "p < end" checks */
-	memset(buf, 0, sizeof(buf));
-	rv = pread(fd, buf, sizeof(buf), 0);
-	assert(0 <= rv && rv <= sizeof(buf));
-	buf[sizeof(buf) - 1] = '\0';
-
-	p = buf;
-
-	val1 = xstrtoull(p, &p);
-	assert(p[0] == '.');
-	assert('0' <= p[1] && p[1] <= '9');
-	assert('0' <= p[2] && p[2] <= '9');
-	assert(p[3] == ' ');
-
-	val2 = (p[1] - '0') * 10 + p[2] - '0';
-	*uptime = val1 * 100 + val2;
-
-	p += 4;
-
-	val1 = xstrtoull(p, &p);
-	assert(p[0] == '.');
-	assert('0' <= p[1] && p[1] <= '9');
-	assert('0' <= p[2] && p[2] <= '9');
-	assert(p[3] == '\n');
-
-	val2 = (p[1] - '0') * 10 + p[2] - '0';
-	*idle = val1 * 100 + val2;
-
-	assert(p + 4 == buf + rv);
-}